Do not allow audio settings to override HB profiles: ipod and iphone
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset drc="0.0"
48 typeset -i default_aid=128
49 typeset -i aid_override=-1
50 typeset -i force_onepass_mode=0
51 typeset -i eject_disk=1
52 typeset -i keep_isofile=0
53 typeset -i keep_vobfile=0
54 typeset -i keep_dvdfolder=0
55 typeset -i keep_intermediate_files=0
56 typeset -i make_final_dest_vob=0
57 typeset -i make_final_dest_iso=0
58 typeset -i make_final_dest_folder=0
59 typeset -i make_final_dest_comp=0
60 typeset -i errors=0
61 typeset -i show_usage=0
62 typeset -i mirror_mode=0
63 typeset -i target_bitrate=2000
64 typeset -i target_size=0
65 typeset -i audio_2ch=0
66 typeset -i audio_6ch=1
67 typeset -i invalid_feature_title=0
68 typeset -i feature_title_override=0
69 typeset -i mplayer_dumpstream_incompatibility=0
70
71 ##############################################################################
72 # Local Machine Settings:
73 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
74 # and the local conf file created by each local machine (rip_dvd.conf)
75 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
76 # This will allow you to override all the default values to meet your needs
77 # in a way that won't get clobbered when you pull updates from my GIT repo.
78 ##############################################################################
79 config="${0%/*}/rip_dvd.conf"
80
81 # The config file will be searched for in the following location order:
82 found_config=0
83
84 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
85 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
86
87 # 2) /path/to/rip_dvd/script/rip_dvd.conf
88 [ -e "${config}" ] && found_config=1 && . "${config}"
89
90 # 3) /etc/rip_dvd.conf
91 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
92
93 # 4) $PWD/rip_dvd.conf
94 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
95
96 # Check to make sure we found the config file
97 if [ $found_config -eq 0 ]; then
98   echo "-E- Unable to find the rip_dvd.conf file: $config"
99   exit 1
100 fi
101
102 ##############################################################################################
103 # Command line processing
104 ##############################################################################################
105 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
106 do
107     case $opt in
108         (n)     dvdname=$OPTARG;;
109         (d)     dest=$OPTARG;;
110         (b)     target_bitrate=$OPTARG;;
111         (s)     target_size=$OPTARG;;
112         (2)     audio_2ch=1;;
113         (6)     audio_6ch=1;;
114         (1)     force_onepass_mode=1;;
115         (v)     make_final_dest_vob=1;;
116         (i)     make_final_dest_iso=1;;
117         (f)     make_final_dest_folder=1;; 
118         (z)     make_final_dest_comp=1;;
119         (e)     encoder=$OPTARG;;
120         (m)     mirror_mode=1;;
121         (k)     keep_intermediate_files=1;;
122         (t)     feature_title_override=$OPTARG;;
123         (a)     aspect=$OPTARG;;
124         (p)     profile=$OPTARG;;
125         (x)     extension=$OPTARG;;
126         (j)     eject_disk=$OPTARG;;
127         (l)     aid_override=$OPTARG;;
128         (r)     drc=$OPTARG;;
129         (w)     set -x;;
130         (h)     show_usage=1;;
131         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
132         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
133     esac
134 done
135
136 shift $((OPTIND-1))
137
138 function usage() {
139     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
140     echo >&2 "Revision $REV"
141     echo >&2 "Options:"
142     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
143     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
144     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
145     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
146     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
147     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
148     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
149     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
150     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
151     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
152     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
153     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
154     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
155     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
156     echo >&2 "                 Handbrake Only Encoder Profiles:"
157     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
158     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
159     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
160     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
161     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
162     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
163     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
164     echo >&2 "                 The default operation is non-mirror mode where only the main"
165     echo >&2 "                 feature title will be ripped."
166     echo >&2 "   -v            Make the final image a DVD VOB file"
167     echo >&2 "   -i            Make the final image a DVD ISO file"
168     echo >&2 "   -f            Make the final image a DVD folder"
169     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
170     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
171     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
172     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
173     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
174     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
175     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
176     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
177     echo >&2 "   -j <n>        Eject the disk:"
178     echo >&2 "                 - 0 = do not eject the disk"
179     echo >&2 "                 - 1 = eject after the entire script is done (default)"
180     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
181     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
182     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
183     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
184     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
185     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
186     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
187     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
188     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
189     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
190     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
191     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
192     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
193     echo >&2 ""
194     exit 2
195 }
196
197 if (($errors)) || (($show_usage))
198 then
199   usage
200 fi
201
202 # Sanity Check - Command Line Options 
203 if [ "$dest" == "" ]; then
204   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
205   usage
206 fi
207
208 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
209    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
210     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
211     make_final_dest_comp=1
212 fi
213
214 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
215   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
216   usage
217 fi
218
219 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
220   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
221   usage
222 fi
223
224 if [ $mirror_mode -eq 1 ]; then
225   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
226      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
227     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
228     usage
229   fi
230 fi
231
232 # Make handbrake the default encoder if not specified and we can find it
233 if [ -z "$encoder" ]; then
234   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
235   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
236   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
237   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
238   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
239 fi
240
241 # Sanity check the profile selection
242 if [[ "$encoder" == "mencoder" ]]; then
243   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
244 fi
245
246 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
247   echo "-E- Invalid encoder specified: $encoder"
248   exit 1
249 fi
250
251 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
252 if [ "$aspect" != "" ]; then
253   echo "$aspect" | grep -q "x"
254   if [ $? == 0 ]; then
255     echo "-E- You must specify the aspect option with a value whose format is W:H"
256     exit 1
257   fi
258   echo "$aspect" | grep -q ":"
259   if [ $? != 0 ]; then
260     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
261     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
262   else
263     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
264     if [ "$encoder" == "handbrake" ]; then
265        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
266        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
267        SCALE="-w $WIDTH -l $HEIGHT"
268     fi
269   fi
270 fi
271
272 # Sanity Check - Key executables
273 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
274 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
275 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
276 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
277 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
278 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
279 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
280 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
281 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
282 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
283 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
284 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
285 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
286
287 ##############################################################################################
288
289 typeset -i ripdvd
290 if [ -z "$dvdname" ]; then
291
292   # make sure the DVD device is accessible
293   volname $dev > /dev/null 2>&1
294   if [ $? != 0 ]; then
295     echo "-E- Can't access the DVD device $dev"
296     exit 1
297   fi
298   # now capture the volume name from the device
299   dvdname=`volname $dev | awk '{ print $1 }'`
300   ripdvd=1
301
302 else 
303
304   # check to see if dvdname is a full path to a real directory
305   # if it is, set dvdname and dvdpath appropriately
306   if [ -d "$dvdname" ]; then
307     dvdpath="$dvdname"
308     dvdname=`basename "$dvdname"`
309     keep_dvdfolder=1
310     if [ -z "$dvdname" ]; then
311      echo "-E- Unable to extract dvdname from path: $dvdpath"
312      exit 1
313     fi
314     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
315       echo "-E- You must supply a full path to a valid DVD folder with this option"
316       exit 1
317     fi
318   fi
319
320   # Check to see if dvdname is a full path to a file
321   if [ -f "$dvdname" ]; then
322     valid_file=0
323
324     # check to see if dvdname is a full path to an MPG2 (VOB) file
325     # if it is, set dvdname and vobfile appropriately
326     file "$dvdname" | grep -q "MPEG"
327     if [ $? == 0 ]; then
328       # It is a valid MPEG2 file, now strip the extension off our dvdname
329       vobfile="$dvdname"
330       dvdname=`basename "$dvdname"`
331       dvdname=${dvdname%.[^.]*}
332       keep_vobfile=1
333       valid_file=1
334     fi
335
336     # check to see if dvdname is a full path to an ISO file
337     # if it is, set dvdname and isofile appropriately
338     file "$dvdname" | grep -q -e "ISO" -e "UDF"
339     if [ $? == 0 ]; then
340       # It is a valid ISO file, now strip the extension off our dvdname
341       isofile="$dvdname"
342       dvdname=`basename "$dvdname"`
343       dvdname=${dvdname%.[^.]*}
344       keep_isofile=1
345       valid_file=1
346     fi    
347
348     # check to see if dvdname is a full path to an ISO file
349     # if it is, set dvdname and isofile appropriately
350     file "$dvdname" | grep -q -e "VOB"
351     if [ $? == 0 ]; then
352       # It is a valid VOB file, now strip the extension off our dvdname
353       vobfile="$dvdname"
354       dvdname=`basename "$dvdname"`
355       dvdname=${dvdname%.[^.]*}
356       keep_vobfile=1
357       valid_file=1
358     fi    
359
360     # If we didn't find a handler for the file above, complain
361     if [ $valid_file -eq 0 ]; then
362       echo "-E- Unsupported file type: $vobfile"
363       exit 1
364     fi
365
366   # Throw an error if we can't find what the -n option is pointing to
367   else 
368     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
369     exit 1
370   fi
371
372   # Set the ripdvd flag to false since we aren't ripping a DVD disk
373   ripdvd=0
374
375   # Since we aren't ripping a DVD disk, don't eject anything either
376   eject_disk=0
377
378 fi
379
380 # remove bad characters from the dvdname
381 dvdname=${dvdname%.} # remove trailing '.' character
382
383 # add the suffix extension to the end of the dvdname
384 dvdname=$dvdname$extension
385
386 # make a "safe" dvdname (remove special characters)
387 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
388
389 # Make sure we have a non-empty dvdname
390 if [ -z "$dvdname" ]; then
391   echo "-E- unable to determine dvdname"
392   exit 1
393 fi
394
395 # make sure our vobfile value is set
396 if [ -z "$vobfile" ]; then
397   vobfile="$dest/$dvdname.VOB"
398 fi
399
400 # set up some variables to hold various logfiles
401 logfile="$logdir/$dvdname.log"
402 passlogfile="$tmpdir/$safedvdname.log"
403 ddrescuelog=`tempfile`
404 dvdauthorlog=`tempfile`
405 encodelog=`tempfile`
406 dumplog=`tempfile`
407
408 # create the tmpdir if it doesn't already exist
409 if [ ! -d "$tmpdir" ]; then
410   mkdir -p "$tmpdir"
411   if [ $? != 0 ]; then
412     echo "-E- Unable to create the tmpdir: $tmpdir"
413     exit 1
414   fi
415 fi
416
417 # create the logdir if it doesn't already exist
418 if [ ! -d "$logdir" ]; then
419   mkdir -p "$logdir"
420   if [ $? != 0 ]; then
421     echo "-E- Unable to create the logdir: $logdir"
422     exit 1
423   fi
424 fi
425
426 ##############################################################################################
427 # cleanup functions
428 ##############################################################################################
429 cleanup() { 
430   if [ $keep_intermediate_files -eq 0 ]; then
431     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
432     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
433     [[ -e "$encodelog" ]] && rm -f "$encodelog"
434     [[ -e "$dumplog" ]] && rm -f "$dumplog"
435   else
436     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
437     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
438     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
439     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
440   fi
441   echo ""
442 }
443
444 fatal_and_exit() {
445   if [[ -z "$1" ]]; then
446     msg="-E- control-c killed us"
447   else
448     msg=$1
449   fi
450   echo -e 2>&1 "$msg" | tee -a "$logfile"
451   if [[ -n "$mailto" ]]; then
452     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
453   fi
454   keep_intermediate_files=1
455   exit 1
456 }
457
458 # Call our cleanup functions on INT and EXIT signals
459 trap fatal_and_exit INT
460 trap cleanup EXIT
461
462 ##############################################################################################
463 # processing functions
464 ##############################################################################################
465
466 # encode the vob file into a compressed file format using handbrake
467 function encode_vob_file_handbrake {
468   
469   # declare some globals
470   typeset handbrake_cli=""
471   typeset handbrake_video_encoder_opts=""
472   typeset filetype=""
473   typeset handbrake_audio_opts=""
474   typeset hb_profile=""
475
476   # Set a variable that we will use later to determine if we found a handler for $profile or not
477   typeset -i found_profile=0    
478
479   # For a given profile, to override the 2 pass behavior to be single pass,
480   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
481   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
482   PASSES="-2"
483
484   # Set our DRC option
485   DRC="-D $drc"
486
487   # Check the global force_onepass_mode. If it is set, change our variables appropriately
488   # to force 1-pass encoding across all profiles.
489   if [ $force_onepass_mode -eq 1 ]; then
490     PASSES=""
491   fi
492
493   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
494   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
495
496   # XVID profile
497   if [[ "$profile" =~ "xvid" ]]; then
498     found_profile=1
499     handbrake_cli="$handbrake_xvid"
500     final_output_file="$dest/$dvdname.avi"
501     filetype="avi"
502
503     # Very High Quality (16fps)
504     if [ "$profile" == "xvidvhq" ]; then
505       handbrake_opts[0]="-f avi"
506       handbrake_opts[1]="-b $target_bitrate"
507       handbrake_opts[2]="-e xvid"
508       handbrake_opts[3]="-T"
509       handbrake_opts[4]="-5"
510       handbrake_opts[5]="-8"
511     fi
512     # High Quality (20fps)
513     if [ "$profile" == "xvidhq" ]; then
514       handbrake_opts[0]="-f avi"
515       handbrake_opts[1]="-b $target_bitrate"
516       handbrake_opts[2]="-e ffmpeg"
517       handbrake_opts[3]="-T"
518       handbrake_opts[4]="-5"
519     fi
520     # Fast (28fps)
521     if [ "$profile" == "xvid" ]; then
522       handbrake_opts[0]="-f avi"
523       handbrake_opts[1]="-b $target_bitrate"
524       handbrake_opts[2]="-e ffmpeg"
525       handbrake_opts[3]="-T"
526     fi
527   fi
528
529   # MP4 profile
530   if [[ "$profile" =~ "mp4" ]]; then
531     found_profile=1
532     handbrake_cli="$handbrake_mp4"
533     final_output_file="$dest/$dvdname.mp4"
534     PASSES=""
535
536     # Very High Quality
537     if [ "$profile" == "mp4vhq" ]; then
538       profile="hb_High_Profile"
539     fi
540     # High Quality
541     if [ "$profile" == "mp4hq" ]; then
542       profile="hb_Normal"
543     fi
544     # Fast
545     if [ "$profile" == "mp4" ]; then
546       profile="hb_Classic"
547     fi
548   fi
549
550   # iphone and ipod MP4 profiles
551   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
552     found_profile=1
553     handbrake_cli="$handbrake_mp4"
554     final_output_file="$dest/$dvdname.mp4"
555     PASSES=""
556
557     # Do not override the audio settings for these profiles
558     audio_2ch=0
559     audio_6ch=0
560
561     # iphone
562     if [ "$profile" == "iphone" ]; then
563       profile="hb_iPhone"
564     fi
565     # ipod
566     if [ "$profile" == "ipod" ]; then
567       profile="hb_iPod"
568     fi
569   fi
570   
571   # Predefined Handbrake Profile Handling
572   if [[ "$profile" =~ "hb" ]]; then
573     found_profile=1
574     handbrake_cli="$handbrake_mp4"
575     final_output_file="$dest/$dvdname.mp4"
576     PASSES=""
577     
578     # extract the HandBrake Profile name from $profile
579     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
580   fi
581
582   # Make sure we found a handler for the given profile
583   if [ $found_profile -eq 0 ]; then
584     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
585   fi
586
587   # setup our audio option
588   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
589     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
590   fi
591   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
592     handbrake_audio_opts="-E ac3 -6 auto"
593   fi
594   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
595     handbrake_audio_opts="-E faac -6 dpl2"
596   fi
597   if [ -n "$track" ]; then
598     handbrake_audio_opts="$handbrake_audio_opts -a $track"
599   fi
600
601   # Convert our array of opts into a string
602   for OPTS in "${video_encoder_opts[@]}"; do 
603     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
604   done
605   if [ -n "$handbrake_video_encoder_opts" ]; then
606     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
607   fi
608   for OPTS in "${handbrake_opts[@]}"; do 
609     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
610   done
611
612   # Append "global" command line options
613   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
614   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
615   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
616   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
617
618   # Execute the handbrake command to encode the video
619   if [ -n "$hb_profile" ]; then
620     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
621     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
622     handbrake_retval=$?
623   else 
624     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
625     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
626     handbrake_retval=$?
627   fi
628   if [ $handbrake_retval != 0 ]; then
629     fatal_and_exit "-E- Unhandled handbrake error"
630   fi
631
632   # Concatenate the encode log to our main log file, greping out unwanted lines
633   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
634   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
635   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
636 }
637
638 # encode the vob file into a compressed file format using mencoder
639 function encode_vob_file_mencoder {
640
641   # Set a variable that we will use later to determine if we found a handler for $profile or not
642   typeset -i found_profile=0
643
644   # For a given profile, to override the 2 pass behavior to be single pass,
645   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
646   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
647   PASSES="1 2"
648
649   # Declare our default 2 pass variables
650   passlogfile_opt="-passlogfile $passlogfile"
651   pass_opt="pass=%PASS"
652
653   # Check the global force_onepass_mode. If it is set, change our variables appropriately
654   # to force 1-pass encoding across all profiles.
655   if [ $force_onepass_mode -eq 1 ]; then
656     PASSES="2"
657     passlogfile_opt=""
658     pass_opt=""    
659   fi
660
661   # XVID profile
662   if [[ "$profile" =~ "xvid" ]]; then
663     found_profile=1
664     final_output_file="$dest/$dvdname.avi"
665     mencoder_general_opts="$lang_opts $passlogfile_opt"
666     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
667     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
668     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
669
670     # Very High Quality (16fps)
671     if [ "$profile" == "xvidvhq" ]; then
672       video_encoder_opts[0]="bitrate=$target_bitrate"
673       video_encoder_opts[1]="threads=$mencoder_threads"
674       video_encoder_opts[2]="chroma_opt"
675       video_encoder_opts[3]="vhq=4"
676       video_encoder_opts[4]="bvhq=1"
677       video_encoder_opts[5]="quant_type=mpeg"
678       video_encoder_opts[6]="autoaspect"
679     fi
680     # High Quality (20fps)
681     if [ "$profile" == "xvidhq" ]; then
682       video_encoder_opts[0]="bitrate=$target_bitrate"
683       video_encoder_opts[1]="threads=$mencoder_threads"
684       video_encoder_opts[2]="chroma_opt"
685       video_encoder_opts[3]="vhq=2"
686       video_encoder_opts[4]="bvhq=1"
687       video_encoder_opts[5]="quant_type=mpeg"
688       video_encoder_opts[6]="autoaspect"
689     fi
690     # Fast (28fps)
691     if [ "$profile" == "xvid" ]; then
692       video_encoder_opts[0]="bitrate=$target_bitrate"
693       video_encoder_opts[1]="threads=$mencoder_threads"
694       video_encoder_opts[2]="vhq=0"
695       video_encoder_opts[3]="turbo"
696       video_encoder_opts[4]="autoaspect"
697     fi
698
699     for OPTS in "${video_encoder_opts[@]}"; do 
700       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
701     done
702
703     if [ $audio_2ch -eq 0 ]; then
704       # These options produce good 6 channel audio for linux and windows
705       mencoder_audio_opts="-oac copy"
706       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
707       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
708       mencoder_audioch_opts[1]="-af channels=6"
709       mencoder_audioch_opts[2]=""
710     else
711       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
712       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
713       mencoder_audioch_opts[0]=""
714     fi
715  
716   fi
717
718   # iphone and ipod MP4 profiles
719   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
720     found_profile=1
721     if [ "$profile" == "iphone" ]; then
722       # SCALE: 480x320
723       # scale width to 480, set height appropriately, but keep a multiple of 16
724       #SCALE=",scale=480:-10"
725       # scale the video down however far is necessary to fit in 480x320
726       SCALE=",dsize=480:320:0,scale=-8:-8"
727     else
728       # SCALE: 320x240
729       # scale width to 320, set height appropriately, but keep a multiple of 16
730       #SCALE=",scale=320:-10"
731       # scale the video down however far is necessary to fit in 320x240
732       SCALE=",dsize=320:240:0,scale=-8:-8"
733     fi
734     final_output_file="$dest/$dvdname.mp4"
735     mencoder_general_opts="$lang_opts $passlogfile_opt"
736     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
737     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
738     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
739     video_encoder_opts[0]="bitrate=$target_bitrate"
740     video_encoder_opts[1]="threads=$mencoder_threads"
741     video_encoder_opts[2]="vbv_maxrate=1500"
742     video_encoder_opts[3]="vbv_bufsize=2000"
743     video_encoder_opts[4]="nocabac"
744     video_encoder_opts[5]="me=umh"
745     video_encoder_opts[6]="subq=6"
746     video_encoder_opts[7]="frameref=6"
747     video_encoder_opts[8]="trellis=1"
748     video_encoder_opts[9]="level_idc=30"
749     video_encoder_opts[10]="global_header"
750     video_encoder_opts[11]="bframes=0"
751     video_encoder_opts[12]="partitions=all"
752     for OPTS in "${video_encoder_opts[@]}"; do 
753       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
754     done
755
756     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
757     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
758   fi
759
760   if [ $found_profile -eq 0 ]; then
761     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
762   fi
763
764   # Do not edit this line. $mencoder_video_encoder_opts must be last
765   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
766   mencoder_retval=0
767
768   for PASS in $PASSES
769   do 
770     # Set some options based on which pass we are in
771     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
772     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
773     [ $PASS -eq 1 ] && output_file="/dev/null"
774     [ $PASS -eq 2 ] && output_file="$final_output_file"
775   
776     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
777     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
778     do
779       echo -e "   Encoding pass $PASS"
780       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
781       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
782       mencoder_retval=$? 
783       grep -q "\[channels\] Invalid" $encodelog
784       if [ $? != 0 ]; then          
785         break;
786       else
787         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
788       fi
789     done
790       
791     if [ $mencoder_retval != 0 ]; then
792       fatal_and_exit "-E- Unhandled mencoder error"
793     fi
794
795     # Concatenate the encode log to our main log file, greping out unwanted lines
796     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
797
798   done
799 }
800
801 function make_dvd_iso_image {
802
803   isofile="$1"
804
805   # check to see if we have a dvdpath to rip from instead of $dev
806   if [ -z "$dvdpath" ]; then
807     # load the CSS codes in the DVD drive 
808     lsdvd $dev >> "$logfile"
809     if [ $? != 0 ]; then
810       fatal_and_exit "-E- lsdvd $dev failed" 
811     fi
812
813     # read the DVD, ignoring/skipping CRC errors
814     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
815     if [ $? != 0 ]; then
816       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
817     fi
818     cat "$ddrescuelog" >> "$logfile"
819   else
820     # rip from a path instead
821     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
822   fi
823 }
824
825 function make_dvd_iso_image_from_folder {
826   
827   src="$1"
828   dst="$2"
829   handle_error=$3
830   
831   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
832
833   # make an iso image out of our directory
834   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
835   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
836
837   # set the audio languages from the iso if it exists and is non-zero in size
838   if [ -s "$dst" ]; then
839     get_feature_title "$dst"
840     get_audio_id_from_iso "$dst"
841   fi
842
843   # make sure we were able to create the iso image from the folder given to us
844   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
845     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
846     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
847     # remove the bad iso file
848     [[ -e "$dst" ]] && rm -f "$dst"
849     # get the feature title from the DVD folder
850     get_feature_title "$dvdpath"
851     # create our main VOB file from the ISO
852     create_main_vob_with_mplayer "$dvdpath" 
853     # get our audio id from the VOB file
854     get_audio_id_from_vob "$vobfile"
855   fi
856 }
857
858 function make_dvdbackup_folder_image {
859   # extract the feature title from the DVD image
860   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
861   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
862   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
863   if [ $? != 0 ]; then
864     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
865   fi
866 }
867
868 function make_dvdauthor_folder_image {
869   # create a new DVD video of the feature title
870   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
871   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
872   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
873   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
874
875   # There is a chance that dvdauthor won't like some of the VOBs.
876   # We can't tell ahead of time which ones it will choke on. 
877   # So, we need to run it over and over again until it can process
878   # all the VOBs. If it can't handle one of them, run it through
879   # mencoder to fix it and try again. These errors are typically
880   # present due to the copy protection that ddrescue removed.
881   grep -q "SCR moves" $dvdauthorlog
882   while [ $? == 0 ]; do
883     # fix bad vobs that get the "SCR moves backwards" error:
884     #  STAT: Processing VTS_01_0.VOB...
885     #  ERR:  SCR moves backwards, remultiplex input.
886     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
887     if [[ ! -f "$badvob" ]]; then
888       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
889     fi
890     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
891     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
892     mv -f $badvob.fixed $badvob
893     echo "-> Creating DVD video $dest/$dvdname"
894     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
895     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
896     grep -q "SCR moves" $dvdauthorlog
897   done
898 }
899
900 function get_feature_title {
901   source="$1"
902   # if a feature title was given on the command line, use it
903   if [ $feature_title_override -ne 0 ]; then
904     feature_title=$feature_title_override
905     return 0
906   fi
907   # otherwise, use lsdvd to figure it out
908   if [ $ripdvd -eq 1 ]; then
909     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
910   else 
911     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
912   fi
913 }
914
915 function create_main_vob_with_cat {
916   # cd to the feature title DVD folder
917   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
918   if [ $? != 0 ]; then
919     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
920   fi
921
922   # concatenate all the VOBs together into 1 giant VOB
923   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
924   cat $vobs > "$tmpdir/$dvdname.VOB"
925
926   # cd back to the dir we started from
927   popd > /dev/null 2>&1
928 }
929
930 function create_main_vob_with_mplayer {
931
932   # argument processing  
933   source="$1"
934   remove_dumplog=$2
935
936   # make sure we have a valid feature title
937   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
938     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
939   fi
940
941   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
942   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
943     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
944     msg="$msg We also detected another condition that requires us to use dumpstream. "
945     msg="$msg\n    Unable to rip this DVD in the mode you requested."
946     fatal_and_exit "$msg"
947   fi
948
949   # use mplayer to create the main VOB file
950   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
951   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
952   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
953   if [ $? != 0 ]; then
954     cat $dumplog | grep -v "^A:" >> "$logfile"
955     fatal_and_exit "-E- Mplayer Failed"
956   fi
957   cat $dumplog | grep -v "^A:" >> "$logfile"
958   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
959 }
960
961 function get_audio_id_from_iso {
962   # Adjust our audio ID to find the english audio stream
963   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
964   iso="$1"
965   aidcheck=`tempfile`
966   aid=$default_aid
967   alang=$default_alang
968   if [ $aid_override -lt 0 ]; then 
969     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
970     grep -q "aid: $aid" $aidcheck
971     while [ $? == 1 ] && [ $aid -lt 159 ]; do
972       (( aid = aid + 1 ))
973       grep -q "aid: $aid" $aidcheck
974     done
975     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
976   else
977     aid=$aid_override
978   fi
979   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
980   # mencoder default DVD audio track language selection (english)
981   lang_opts="-aid $aid -alang $alang"
982 }
983
984 function get_crop_from_iso { 
985   FRAMES=10000
986   echo "-> Detecting black frame border crop value from ISO file"
987   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
988   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
989   [[ -e "md5sums" ]] && rm -f "md5sums"
990   CROP=`cat $dumplog | grep CROP | tail -1`
991   echo "   Found crop value of $CROP" >> "$logfile"
992   CROP=${CROP#* crop=}
993   CROP=${CROP%%\).*}
994   typeset -i CROPCHECK
995   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
996   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
997   if [ -z "$CROP" ]; then
998     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
999     return
1000   fi
1001   if [ $CROPCHECK -lt 0 ]; then 
1002     CROP=""
1003   else 
1004     CROP=",crop=$CROP"
1005   fi
1006   echo "   Setting mencoder crop filter to: $CROP"
1007 }
1008
1009 function get_crop_from_vob { 
1010   FRAMES=10000
1011   echo "-> Detecting black frame border crop value from VOB file"
1012   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1013   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1014   [[ -e "md5sums" ]] && rm -f "md5sums"
1015   CROP=`cat $dumplog | grep CROP | tail -1`
1016   echo "   Found crop value of $CROP" >> "$logfile"
1017   CROP=${CROP#* crop=}
1018   CROP=${CROP%%\).*}
1019   typeset -i CROPCHECK
1020   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1021   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1022   if [ -z "$CROP" ]; then
1023     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1024     return
1025   fi
1026   if [ $CROPCHECK -lt 0 ]; then 
1027     CROP=""
1028   else 
1029     CROP=",crop=$CROP"
1030   fi
1031   echo "   Setting mencoder crop filter to: $CROP"
1032 }
1033
1034 function get_audio_track_from_vob {
1035   # Adjust our audio ID to find the english audio stream
1036   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1037   vob="$1"
1038   handbrake_cli="$2"
1039   aidcheck=`tempfile`
1040   aid=$default_aid
1041   alang=$default_alang
1042   if [ $aid_override -lt 0 ]; then 
1043     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1044     grep -q "Found audio stream: $aid" $aidcheck
1045     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1046       (( aid = aid + 1 ))
1047       grep -q "Found audio stream: $aid" $aidcheck
1048     done
1049     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1050   else 
1051     aid=$aid_override
1052   fi
1053   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1054
1055   # convert the aid we found into hex
1056   aid_hex=`echo "obase=16; $aid" | bc`
1057   
1058   # extract the audio streams in the vob
1059   #ffmpeg -i "$vob" > $aidcheck 2>&1
1060   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1061   
1062   # find the stream that matches our aid
1063   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1064   stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1065  
1066   # extract the track number that handbrake uses
1067   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1068   track=`expr match "$stream" '^\([0-9]*\):'`
1069
1070   if [ -n "$track" ]; then   
1071     echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1072   fi
1073 }
1074
1075 function get_audio_id_from_vob {
1076   # Adjust our audio ID to find the english audio stream
1077   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1078   vob="$1"
1079   aidcheck=`tempfile`
1080   aid=$default_aid
1081   alang=$default_alang
1082   if [ $aid_override -lt 0 ]; then 
1083     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1084     grep -q "Found audio stream: $aid" $aidcheck
1085     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1086       (( aid = aid + 1 ))
1087       grep -q "Found audio stream: $aid" $aidcheck
1088     done
1089     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1090   else 
1091     aid=$aid_override
1092   fi
1093   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1094   # mencoder default DVD audio track language selection (english)
1095   lang_opts="-aid $aid -alang $alang"
1096 }
1097
1098 function check_vob_for_corrupted_start {
1099   # check to see if the beginning of the DVD has a form of copy protection
1100   # where they have deliberately broken the first X number of frames of the DVD.
1101   # If we don't skip these, our resulting VOB file will not play.
1102   badvobcheck=`tempfile`
1103   endpos=360
1104   skip=0
1105   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1106   if [ $? != 0 ]; then
1107     fatal_and_exit "-E- Mencoder Failed"
1108   fi
1109   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1110   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1111     (( skip = skip + 5 ))
1112     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1113     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1114     if [ $? != 0 ]; then
1115       fatal_and_exit "-E- Mencoder Failed"
1116     fi
1117     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1118   done
1119   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1120
1121   # cat the giant VOB into mencoder to create a playable VOB file
1122   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1123   if [ $? != 0 ]; then
1124     fatal_and_exit "-E- Mencoder Failed"
1125   fi
1126 }
1127
1128 function check_vob_for_completeness {
1129   # check to make sure we got out a complete VOB.
1130   # there is another kind of copy protection where the VOB's may
1131   # have "MPG EOF" frames in the middle of the stream. 
1132   # this causes mencoder to not process the entire VOB, and exit without any errors.
1133   # detect this by seeing how much smaller the dst vob is from the src vob.
1134   MAX_FILESIZE_DELTA_PERCENT=70
1135   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1136   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1137   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1138   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1139     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1140     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1141     create_main_vob_with_mplayer "$isofile"
1142     [[ -e "$dumplog" ]] && rm -f $dumplog
1143     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1144     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1145     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1146       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1147     fi
1148   fi
1149 }
1150
1151 function check_vob_for_too_many_video_packets {
1152   # If our earlier algorithm to work around this failed, throw an error.
1153   # check to see if this DVD has a protection scheme we don't know how to work around
1154   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1155   # for some reason, the video is black, while the audio rolls, then the video finally comes
1156   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1157   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1158   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1159   grep -q "Too many video packets in the buffer:" "$logfile"
1160   if [ $? == 0 ]; then
1161     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1162     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1163     create_main_vob_with_mplayer "$isofile"
1164     grep -q "Too many video packets in the buffer:" $dumplog
1165     if [ $? == 0 ]; then
1166       [[ -e "$dumplog" ]] && rm -f $dumplog
1167       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1168     fi
1169     [[ -e "$dumplog" ]] && rm -f $dumplog
1170   fi
1171 }
1172
1173 function check_vob_for_a52_crc_errors {
1174   # Let's see if we can playback our newly created VOB file without any errors.
1175   # if there are issues, let's detect them now, and try to recreate the VOB
1176   # there are some forms of copy protection that have missed above, that evidence
1177   # themselves when we try to playback the VOB file. This was added to deal with
1178   # the "a52: CRC check failed" copy protection scheme.
1179   MAX_ERRORS=10
1180   ENDPOS=120
1181   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1182   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1183   cat $dumplog | grep -v "^A:" >> "$logfile"
1184   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1185   if [ $errors -gt $MAX_ERRORS ]; then
1186     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1187     create_main_vob_with_mplayer "$isofile"
1188     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1189     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1190     if [ $? != 0 ]; then
1191       cat $dumplog | grep -v "^A:" >> "$logfile"
1192       fatal_and_exit "-E- Mplayer Failed"
1193     fi
1194     cat $dumplog | grep -v "^A:" >> "$logfile"
1195     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1196     if [ $errors -gt $MAX_ERRORS ]; then
1197       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1198     fi
1199   fi
1200   [[ -e "$dumplog" ]] && rm -f $dumplog
1201 }
1202
1203 function calculate_bitrate_from_target_size {
1204   # determine what our bitrate needs to be if a target size was specified instead
1205   if [ $target_size -ne 0 ]; then
1206     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1207     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1208     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1209   fi
1210 }
1211
1212 function create_dvdauthor_dvd_xml_file {
1213   # make a dvdauthor xml menu file to create a valid DVD video from 
1214   # this script does a good job, but we'll still need to clean it up a bit after it runs
1215   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1216   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1217   if [ $? != 0 ]; then
1218     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1219   fi
1220
1221   # replace the first line of the xml file to remove the bad dest path
1222   awk -v line=1 -v new_content="<dvdauthor>" '{
1223     if (NR == line) {
1224       print new_content;
1225     } else {
1226       print $0;
1227     }
1228   }' dvd.xml > dvd.xml.new
1229   mv -f dvd.xml.new dvd.xml
1230   if [ $? != 0 ]; then
1231     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1232   fi
1233
1234   # remove the "<video " property line from the xml file
1235   cat dvd.xml | grep -v "<video" > dvd.xml.new
1236   mv -f dvd.xml.new dvd.xml
1237   if [ $? != 0 ]; then
1238     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1239   fi
1240   
1241   # remove the extra <pgc>..</pgc> pairs
1242   cat dvd.xml | awk 'BEGIN {x=1}
1243   {
1244     if ($0~"</pgc>") {x=0}
1245     if (x==1) {print $0}
1246     if ($0~"<pgc>") {x=1}
1247   }' > dvd.xml.new
1248   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1249   mv -f dvd.xml.new dvd.xml
1250   if [ $? != 0 ]; then
1251     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1252   fi
1253
1254   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1255   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1256   mv -f dvd.xml.new dvd.xml
1257   if [ $? != 0 ]; then
1258     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1259   fi
1260 }
1261
1262 function check_for_mplayer_dumpstream_incompatibility {
1263
1264   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1265
1266   if [ ! -e "$vobfile" ]; then
1267     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1268     # A DVD that has 99 titles, where the longest title isn't the main feature
1269     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1270     # out what the feature title is. This script will run through that flow if we
1271     # set use_mplayer_dumpstream to 0. Check for this here.
1272     if [ $ripdvd -eq 1 ]; then
1273       lsdvd $dev | grep -q "Title: 99"
1274     else
1275       lsdvd "$isofile" | grep -q "Title: 99"
1276     fi
1277     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1278     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1279       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1280         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1281         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1282         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1283         invalid_feature_title=1
1284       else 
1285         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1286         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1287         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1288         use_mplayer_dumpstream=0
1289         invalid_feature_title=1
1290       fi
1291       return
1292     fi
1293   fi
1294
1295   # There is another form of protection that causes the mplayer dumpstream to fail. 
1296   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1297   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1298   # problem before continuing.
1299   if [ -e "$vobfile" ]; then
1300     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1301     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1302     grep -q "Too many audio packets in the buffer" $dumplog
1303     if [ $? == 0 ]; then
1304       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1305       use_mplayer_dumpstream=0
1306       mplayer_dumpstream_incompatibility=1
1307     fi
1308     [[ -e "$dumplog" ]] && rm -f $dumplog
1309   fi
1310 }
1311
1312 function fill_mythvideo_metadata {
1313
1314   # This function must be passed the filename as an argument
1315   # The filename must be a full path to the file
1316   filename="$1"
1317
1318   # Make sure the fill mythvideo metadata option has been set to 1
1319   if [ $fill_mythvideo_metadata -eq 0 ]; then
1320     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1321     return 0
1322   fi
1323
1324   # If the fill mythvideo metadata script is present, run it
1325   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1326   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1327     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1328     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1329   else
1330     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1331     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1332   fi
1333 }
1334
1335 # remove the intermediate VOB file
1336 function remove_intermediate_vob_file {
1337   if [ $keep_intermediate_files -eq 0 ]; then
1338     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1339   else
1340     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1341   fi
1342 }
1343
1344 # remove the original DVD image 
1345 function remove_intermediate_iso_file {
1346   [[ $keep_isofile -eq 1 ]] && return 1
1347   if [ $keep_intermediate_files -eq 0 ]; then
1348     [[ -e "$isofile" ]] && rm "$isofile"
1349   else
1350     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1351   fi
1352 }
1353
1354 # remove the intermediate dvdbackup folder
1355 function remove_intermediate_dvdbackup_folder {
1356   if [ $keep_intermediate_files -eq 0 ]; then
1357     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1358   else
1359     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1360   fi
1361 }
1362
1363 ##############################################################################################
1364 # MAIN
1365 ##############################################################################################
1366
1367 # Make a note of when this DVD rip started
1368 date=`date`
1369 echo -e "\n$date DVD rip started" >> "$logfile"
1370 echo "$cmd" >> "$logfile"
1371
1372 # Rip the DVD - Mirror Mode
1373 if [ $mirror_mode -eq 1 ]; then
1374   echo "-> Ripping DVD $dvdname to $dest"
1375
1376   # use ddrescue to make an ISO image of the disk
1377   make_dvd_iso_image "$dest/$dvdname.iso"
1378
1379   # add this video data to the mythtv DB
1380   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1381
1382   # eject the disk upon completion
1383   if [ $eject_disk -ne 0 ]; then
1384     eject -T $dev
1385   fi
1386
1387   date=`date`
1388   echo "$date DVD rip completed" | tee -a "$logfile"
1389
1390   if [[ -n "$mailto" ]]; then
1391     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1392   fi
1393
1394 fi
1395
1396 # Rip the DVD - Main Title Feature Only
1397 if [ $mirror_mode -eq 0 ]; then
1398
1399   # Rip image from DVD
1400   if [ $ripdvd -eq 1 ]; then
1401     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1402     # use ddrescue to make an ISO image of the disk
1403     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1404   fi
1405
1406   # Rip image from DVD path
1407   if [ -n "$dvdpath" ]; then
1408     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1409     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1410   fi
1411
1412   # make sure our isofile value is set
1413   if [ -z "$isofile" ]; then
1414     isofile="$tmpdir/$dvdname.iso"
1415   fi
1416      
1417   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1418
1419     if [ ! -e "$vobfile" ]; then
1420       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1421       
1422       # get the feature title from the ISO
1423       get_feature_title "$isofile"
1424  
1425       # get the crop value from the ISO
1426       get_crop_from_iso
1427
1428       # check for mplayer dumpstream incompatibilities
1429       # if they exist, this method will set this mode to 0.
1430       check_for_mplayer_dumpstream_incompatibility
1431
1432       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1433
1434         # get our audio id from the ISO file
1435         get_audio_id_from_iso "$isofile"
1436
1437         # create our main VOB file from the ISO
1438         create_main_vob_with_mplayer "$isofile"
1439      
1440         # remove the intermediate VOB file
1441         remove_intermediate_vob_file
1442
1443         # it's possible that our VOB is still corrupted in some manner
1444         # check to make sure it is still a good VOB before continuing.
1445         check_for_mplayer_dumpstream_incompatibility
1446
1447       fi
1448  
1449       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1450
1451         # use dvdbackup to make a DVD folder of the feature title
1452         make_dvdbackup_folder_image
1453   
1454         # create our main VOB file
1455         create_main_vob_with_cat
1456
1457         # get our audio id from the VOB file
1458         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1459   
1460         # check for corrupted VOB start
1461         check_vob_for_corrupted_start
1462  
1463         # check to make sure our VOB is complete
1464         check_vob_for_completeness
1465
1466         # check to make sure our VOB doesn't have too many video packets
1467         check_vob_for_too_many_video_packets
1468
1469         # check to make sure our VOB doesn't have a52 crc errors
1470         check_vob_for_a52_crc_errors
1471
1472         # remove the intermediate VOB file
1473         remove_intermediate_vob_file
1474
1475       fi
1476
1477       # remove the intermediate ISO file
1478       remove_intermediate_iso_file
1479
1480     else
1481       if [ "$encoder" != "handbrake" ]; then 
1482         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1483         # get our audio id from the VOB file
1484         get_audio_id_from_vob "$vobfile"
1485         # get the crop value from the VOB
1486         get_crop_from_vob
1487       fi
1488     fi
1489
1490     # eject the DVD disk since we are finished with it
1491     [ $eject_disk -eq 2 ] && eject -T $dev
1492
1493     # encode the VOB file to a compressed file format
1494     if [ $make_final_dest_comp -eq 1 ]; then
1495       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1496
1497       # determine what our bitrate needs to be if a target size was specified instead
1498       calculate_bitrate_from_target_size        
1499      
1500       # encode the vob file into a compressed file format
1501       if [[ "$encoder" == "mencoder" ]]; then 
1502         encode_vob_file_mencoder
1503       fi
1504       if [[ "$encoder" == "handbrake" ]]; then
1505         encode_vob_file_handbrake
1506       fi
1507
1508       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1509         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1510         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1511       else
1512         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1513         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1514       fi
1515     fi
1516
1517   # add this video data to the mythtv DB
1518   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1519   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1520     
1521   else
1522
1523   # use dvdbackup to make a DVD folder of the feature title
1524   make_dvdbackup_folder_image
1525
1526   # cd to the feature title DVD folder
1527   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1528   if [ $? != 0 ]; then
1529     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1530   fi
1531   
1532   # create the dvd.xml file for dvdauthor
1533   create_dvdauthor_dvd_xml_file  
1534
1535   # make the final DVD folder image
1536   make_dvdauthor_folder_image
1537
1538   # add this video data to the mythtv DB
1539   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1540  
1541   # cd back to the dir we started from
1542   popd > /dev/null 2>&1
1543
1544   if [ $make_final_dest_iso -eq 1 ]; then
1545
1546     # make an iso image out of our directory
1547     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1548    
1549     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1550     if [ -s "$dest/$dvdname.iso" ]; then
1551       if [ $make_final_dest_folder -eq 0 ]; then
1552         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1553         # remove the folder of the DVD image now that we have a .iso version of it
1554         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1555       fi
1556     else
1557       # we created an empty iso file, remove it
1558       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1559       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1560       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1561     fi
1562  
1563     # add this video data to the mythtv DB
1564     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1565
1566   fi
1567
1568   fi
1569
1570   # remove the ddrescue DVD ISO image
1571   remove_intermediate_iso_file
1572
1573   # remove the tmp dvdbackup folder of the DVD image
1574   remove_intermediate_dvdbackup_folder
1575
1576   # eject the DVD disk upon completion
1577   [ $eject_disk -eq 1 ] && eject -T $dev
1578
1579   date=`date`
1580   echo "$date DVD rip completed" | tee -a "$logfile"
1581
1582   if [[ -n "$mailto" ]]; then
1583     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1584   fi
1585
1586 fi
1587
1588 ##############################################################################################